Debian Bug report logs - #702036
multistrap: optionally mark dependencies as auto-installed

version graph

Package: multistrap; Maintainer for multistrap is Neil Williams <codehelp@debian.org>; Source for multistrap is src:multistrap.

Reported by: Ryan Kuester <rkuester@insymbols.com>

Date: Sat, 2 Mar 2013 00:24:01 UTC

Severity: wishlist

Tags: patch

Found in version multistrap/2.1.20

Fixed in version multistrap/2.1.22

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#702036; Package multistrap. (Sat, 02 Mar 2013 00:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ryan Kuester <rkuester@insymbols.com>:
New Bug report received and forwarded. Copy sent to Neil Williams <codehelp@debian.org>. (Sat, 02 Mar 2013 00:24:03 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Ryan Kuester <rkuester@insymbols.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: multistrap: optionally mark dependencies as auto-installed
Date: Sat, 2 Mar 2013 00:21:29 +0000
[Message part 1 (text/plain, inline)]
Package: multistrap
Version: 2.1.20
Severity: wishlist
Tags: patch

To enable use of `apt-get autoremove`, it is necessary that packages
which are installed to satisfy dependencies (as opposed to those
packages directly specified, e.g. via a section "packages" list) be
marked as auto-installed in APT's extended_states database. apt-get
normally does this, but not when APT::Get::Download-Only is set, as it
is by multistrap.

The attached patch causes such packages to be so marked if
'markauto' is set to true in the general settings stanza of the
configuration file, e.g.:

----
[general]
....
markauto=true
....

[emdebian]
source=http://emdebian.org/grip
suite=wheezy-grip
....
----

Diffstat of the attached patch:
 multistrap     |   21 ++++++++++++++++++++-
 pod/multistrap |    5 +++++
 2 files changed, 25 insertions(+), 1 deletion(-)


-- System Information:
Debian Release: 7.0
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-4-amd64 (SMP w/8 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages multistrap depends on:
ii  apt                            0.9.7.7
ii  libconfig-auto-perl            0.42-1
ii  liblocale-gettext-perl         1.05-7+b1
ii  libparse-debian-packages-perl  0.03-1
ii  perl                           5.14.2-18

Versions of packages multistrap recommends:
ii  emdebian-archive-keyring  2.0.3

Versions of packages multistrap suggests:
ii  fakeroot  1.18.4-2

-- no debconf information
[markauto.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#702036; Package multistrap. (Sat, 02 Mar 2013 16:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. (Sat, 02 Mar 2013 16:45:06 GMT) Full text and rfc822 format available.

Message #10 received at 702036@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: rkuester@insymbols.com, 702036@bugs.debian.org
Subject: Re: Bug#702036: multistrap: optionally mark dependencies as auto-installed
Date: Sat, 2 Mar 2013 16:42:04 +0000
[Message part 1 (text/plain, inline)]
On Sat, 2 Mar 2013 00:21:29 +0000
Ryan Kuester <rkuester@insymbols.com> wrote:

> To enable use of `apt-get autoremove`, it is necessary that packages
> which are installed to satisfy dependencies (as opposed to those
> packages directly specified, e.g. via a section "packages" list) be
> marked as auto-installed in APT's extended_states database. apt-get
> normally does this, but not when APT::Get::Download-Only is set, as it
> is by multistrap.
> 
> The attached patch causes such packages to be so marked if
> 'markauto' is set to true in the general settings stanza of the
> configuration file, e.g.:

Interesting patch, I think there are problems though. The new function
relies on side-effects of the force_unpack operation. This needs to be
included in the addition to the documentation (that disabling unpack
requires causes the unavoidable disabling of markauto.) The function
call itself should be inside the force_unpack subroutine. (@archives
could be made a local variable at any stage.) Alternatively, mark_auto
needs to rebuild it's own @archives array and keep the two operations
separate, which is probably my preference.

The process also takes a significant amount of time - the start of the
function should use a translatable string as an informational message.
Something like: "Marking automatically installed packages... please
wait" - it could also do with a second message along the lines of
"Found %d packages to mark" and then a "Complete" type message at the
end.

Furthermore, markauto needs to be listed in the dump_config routine so
that --simulate shows if it is enabled (silent if default of disabled).

I'm also not sure about why a new trim function needs to be introduced
instead of using chomp.

my @all = map {
    `LC_ALL=C dpkg -f ${dir}${cachedir}archives/$_ Package`; 
} @archives; 
chomp (@all);

Have you tested this support cross-architecture? Does apt-mark
correctly handle the config_str to prevent pollution of the system
running multistrap? (Please describe if you've
checked /var/lib/apt/extended_states before and after inside the new
chroot and outside it, especially when the chroot is armel on an x86
system etc.)

-- 


Neil Williams
=============
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#702036; Package multistrap. (Thu, 21 Mar 2013 19:42:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. (Thu, 21 Mar 2013 19:42:04 GMT) Full text and rfc822 format available.

Message #15 received at 702036@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 702036@bugs.debian.org
Subject: pending
Date: Thu, 21 Mar 2013 19:41:18 +0000
[Message part 1 (text/plain, inline)]
tag 702036 + pending
quit

-- 


Neil Williams
=============
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Added tag(s) pending. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 21 Mar 2013 19:45:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#702036; Package multistrap. (Thu, 21 Mar 2013 21:00:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ryan Kuester <rkuester@insymbols.com>:
Extra info received and forwarded to list. Copy sent to Neil Williams <codehelp@debian.org>. (Thu, 21 Mar 2013 21:00:09 GMT) Full text and rfc822 format available.

Message #22 received at 702036@bugs.debian.org (full text, mbox):

From: Ryan Kuester <rkuester@insymbols.com>
To: Neil Williams <codehelp@debian.org>
Cc: 702036@bugs.debian.org
Subject: Re: Bug#702036: multistrap: optionally mark dependencies as auto-installed
Date: Thu, 21 Mar 2013 15:30:54 -0500
On Sat, Mar 02, 2013 at 04:42:04PM +0000, Neil Williams wrote:
> On Sat, 2 Mar 2013 00:21:29 +0000
> Ryan Kuester <rkuester@insymbols.com> wrote:
> 
> > The attached patch causes such packages to be so marked if
> > 'markauto' is set to true in the general settings stanza of the
> > configuration file, e.g.:
> 
> Interesting patch, I think there are problems though.

Neil, I see you've marked this bug as pending. Thanks for fixing my
patch up. I applologize this didn't get back to the top of my TODO
list quickly enough.

The logical errors you mentioned were oversights, and the new trim
function and other oddities were just my naïveté with perl. You've
faithfully implemented the intent of my prototype.

I've just given your version from Subversion a spin here, and it
works great.

> Have you tested this support cross-architecture? Does apt-mark
> correctly handle the config_str to prevent pollution of the system
> running multistrap? (Please describe if you've
> checked /var/lib/apt/extended_states before and after inside the new
> chroot and outside it, especially when the chroot is armel on an x86
> system etc.)

Yep, that's the mode in which I usually use it--building filesystems
for armel on amd64.

Thanks again for the useful tool,
-- Ryan



Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. (Thu, 21 Mar 2013 22:21:24 GMT) Full text and rfc822 format available.

Notification sent to Ryan Kuester <rkuester@insymbols.com>:
Bug acknowledged by developer. (Thu, 21 Mar 2013 22:21:24 GMT) Full text and rfc822 format available.

Message #27 received at 702036-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 702036-close@bugs.debian.org
Subject: Bug#702036: fixed in multistrap 2.1.22
Date: Thu, 21 Mar 2013 22:17:47 +0000
Source: multistrap
Source-Version: 2.1.22

We believe that the bug you reported is fixed in the latest version of
multistrap, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 702036@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated multistrap package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 21 Mar 2013 19:21:56 +0000
Source: multistrap
Binary: multistrap
Architecture: source all
Version: 2.1.22
Distribution: experimental
Urgency: low
Maintainer: Neil Williams <codehelp@debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 multistrap - multiple repository bootstrap based on apt
Closes: 695843 702036
Changes: 
 multistrap (2.1.22) experimental; urgency=low
 .
   * Support marking dependencies as auto-installed using apt-mark.
     (Closes: #702036)
   * Fix filehandle typo when configuring multiarch (Closes: #695843)
Checksums-Sha1: 
 90944b0e4c7626160a7b35833b2bfad4a250be32 1710 multistrap_2.1.22.dsc
 b25c57a7ee5c118391bc8c3c443b32bf1d403179 215419 multistrap_2.1.22.tar.gz
 f5b1875a3babb2a866c3b284ae84b541ba1c6868 135384 multistrap_2.1.22_all.deb
Checksums-Sha256: 
 4cb3c26cd152b984bd668170950b07169a13de5a152f8d2b9864803a0606d3d0 1710 multistrap_2.1.22.dsc
 d0cc8fd7e4448b4d006ef55a7a5c17663ecac156b32d17862452a3d9133416b3 215419 multistrap_2.1.22.tar.gz
 0f5f6e4d2ca09a6cdcbb9197cb878c4b027a6b85a266fb0e4167efeb71ee67ba 135384 multistrap_2.1.22_all.deb
Files: 
 b5cebc4a6e55f43fd278b4aac90fa8d1 1710 utils optional multistrap_2.1.22.dsc
 39639fb1eebbb407fcbdc007b7a3e32d 215419 utils optional multistrap_2.1.22.tar.gz
 bfbdbd4f763cee2b64f5c75327793900 135384 admin optional multistrap_2.1.22_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJRS4YOAAoJEPFn5DyBQ7aCHqwP/j8Szhnl59QnXqoTWtcd4WXL
rq/LyEa+gi9/LaMRMp7VOZXjUUwCX5jd32srHOzsj870RfeKLfUGcgfH7wx6OCW6
cti1wNdJTsqFFUSiEyS+Fw2qhl88n0MTd2fh08HVQ/cbkGz1WW9B8SFd2pQCeL1o
xMtaEjgUCRBazTKLvc/bVJN6oziuy080nm3xhe3bVbZhns+fHNotef12SVZ0FFun
zSS0FKwPP4WULFLXGrIVt6jevwrALQ/2QgoXjX035JEWL7gFcpfHKSegnPec9zaf
OpDwiF4oHCOPPd1CXiEtsZogDjxbSazuLSsWrsvXrpAaQ1OqrN0bShjgJQPgWiPU
hvlHdrynCy5wen6jVE6Eg8EoN1GCh/JuUN1YNAvif5e0e+ZwXo3bG22gAL559RJl
dU/FKShE0RxgTXAN2aIxuDAU8DW7WdDzyilx/91GZAIjW7koBRnK+X4JCtYgjs/D
5LoQJjGV/F2sPw2kSmiK25uzV+iWBfP/GII/XsQQpa2jiXBHoNFnEy3RtwW5zFs6
0hk8GLi0TSIUzfEr5Hyys3bQlEfNxuSd0yI8U8dY8biyJKZMfNXsBP6SZuwG4jYZ
rVXKU5JRcVTkTHaGQCaEY3X2vQ73ZCEOGDa+b8CQaI+N9TmzPkPX8FMbLt/GcH24
EXv/3ke761ZOhl/lv7jX
=j3iM
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 25 Jun 2013 07:33:03 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 02:03:31 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.